
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "UART.h"

void uart_init(void)
{
	
	UBRRH = (UBRR_VAL >> 8);
	UBRRL = UBRR_VAL & 0xFF; 
	UCSRB =	(1<<TXEN) | (1<<RXEN);
	UCSRC =	(1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0);
}

void uart_send_byte(char zeichen)
{
	while (!(UCSRA & (1<<UDRE)))				// warten bis UDER 1 
	 	{
		}
	UDR = zeichen;
}

void uart_send_text_p(const char *text)
{
    char zeichen;
 
    while ((zeichen = pgm_read_byte(text)))
    { 
        uart_send_byte(zeichen);
        text++;
    }
}

void uart_send_text(const char *text)
{
    char zeichen;
 
    while ((zeichen = *text))
    { 
        uart_send_byte(zeichen);
        text++;
    }
}
void uart_send_byte_hex(char byte)
{
	char zeichen;
	zeichen = '0' | ((byte & 0xF0) >> 4);
	if (zeichen > '9')
	  {
	    zeichen += 7;
	  }
	uart_send_byte(zeichen);

	zeichen = '0' | (byte & 0x0F);
	if (zeichen > '9')
	  {
	    zeichen += 7;
	  }
	uart_send_byte(zeichen);
}

